package com.ekexiu.project.platform.company;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.Dynamic;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.PageSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2018/11/26.
 */
@DAO
public interface CompanyDao {

    @Insert
    int insert(Connection con, Company company) throws SQLException;

    @Update
    @Dynamic
    int update(Connection con, Company company) throws SQLException;

    @UpdateWith
    @From(Company.class)
    @Where("ACTIVED = '1'")
    @SetSentence("ACTIVED = '0'")
    int delete(Connection con, String id) throws SQLException;

    @SelectOne
    @Nullable
    Company query(Connection con, String id) throws SQLException;

    @SelectOne
    @Nullable
    Company queryByShareId(Connection con, long shareId) throws SQLException;

    @PageSelect
    @OrderBy("ORDER BY CREATE_TIME DESC")
    PageQueryResult<Company> pageQuery(Connection con, @Nullable Boolean actived, @Nullable String name, int pageSize, int pageNo) throws SQLException;

    @Insert
    int insert(Connection con, CompKeyWord compKeyWord) throws SQLException;

    @DeleteWith
    @From(CompKeyWord.class)
    int deleteKeyWord(Connection con, String id) throws SQLException;

    @Insert
    int insert(Connection con, CompInvite compInvite) throws SQLException;

    @UpdateWith
    @From(CompInvite.class)
    @Where("ACTIVED = '1'")
    @SetSentence("ACTIVED = '0'")
    int invited(Connection con, String id) throws SQLException;

}
